# frozen_string_literal: true
require 'rails_helper'

# This spec was generated by rspec-rails when you ran the scaffold generator.
# It demonstrates how one might use RSpec to specify the controller code that
# was generated by Rails when you ran the scaffold generator.
#
# It assumes that the implementation code is generated by the rails scaffold
# generator.  If you are using any extension libraries to generate different
# controller code, this generated spec may or may not pass.
#
# It only uses APIs available in rails and/or rspec-rails.  There are a number
# of tools you can use to make these specs even more expressive, but we're
# sticking to rails and rspec-rails APIs to keep things simple and stable.
#
# Compared to earlier versions of this generator, there is very limited use of
# stubs and message expectations in this spec.  Stubs are only used when there
# is no simpler way to get a handle on the object needed for the example.
# Message expectations are only used when there is no simpler way to specify
# that an instance is receiving a specific message.

RSpec.describe ItemTypesController, type: :controller do
  # This should return the minimal set of attributes required to create a valid
  # item_type. As you add validations to item_type, be sure to
  # adjust the attributes here as well.
  let(:organization) { create(:organization) }
  let(:item_type) { create(:item_type, organization: organization) }

  let(:invalid_attributes) { attributes_for(:item_type, title: nil) }

  # This should return the minimal set of values that should be in the session
  # in order to pass any filters (e.g. authentication) defined in
  # ItemTypesController. Be sure to keep this updated too.
  let(:valid_session) do
    { user_id: { 'uid' => create(:user).uid, 'extra' => { 'is_admin' => true } } }
  end

  describe 'GET #index' do
    it 'assigns all item_types as @item_types' do
      get :index, params: { organization_id: organization.id }, session: valid_session
      expect(assigns(:item_types)).to eq([item_type])
    end
  end

  describe 'GET #show' do
    it 'assigns the requested item_type as @item_type' do
      get :show, params: { organization_id: organization.id, id: item_type.to_param },
                 session: valid_session
      expect(assigns(:item_type)).to eq(item_type)
    end
  end

  describe 'GET #new' do
    it 'assigns a new item_type as @item_type' do
      get :new, params: { organization_id: organization.id }, session: valid_session
      expect(assigns(:item_type)).to be_a_new(ItemType)
    end
  end

  describe 'GET #edit' do
    it 'assigns the requested item_type as @item_type' do
      get :edit, params: { organization_id: organization.id, id: item_type.to_param },
                 session: valid_session
      expect(assigns(:item_type)).to eq(item_type)
    end
  end

  describe 'POST #create' do
    context 'with valid params' do
      it 'creates a new item_type' do
        expect do
          post :create, params: {
            organization_id: organization.id, item_type: attributes_for(:item_type)
          }, session: valid_session
        end.to change(ItemType, :count).by(1)
      end

      it 'assigns a newly created item_type as @item_type' do
        post :create, params: {
          organization_id: organization.id, item_type: attributes_for(:item_type)
        }, session: valid_session
        expect(assigns(:item_type)).to be_a(ItemType)
        expect(assigns(:item_type)).to be_persisted
      end

      it 'redirects to the created item_type' do
        post :create, params: {
          organization_id: organization.id, item_type: attributes_for(:item_type)
        }, session: valid_session
        expect(response).to redirect_to([organization, ItemType.last])
      end
    end

    context 'with invalid params' do
      it 'assigns a newly created but unsaved item_type as @item_type' do
        post :create, params: {
          organization_id: organization.id, item_type: invalid_attributes
        }, session: valid_session
        expect(assigns(:item_type)).to be_a_new(ItemType)
      end

      it "re-renders the 'new' template" do
        post :create, params: { organization_id: organization.id, item_type: invalid_attributes },
                      session: valid_session
        expect(response).to render_template('new')
      end
    end
  end

  describe 'PUT #update' do
    context 'with valid params' do
      let(:new_attributes) { attributes_for(:item_type) }

      it 'updates the requested item_type' do
        put :update, params: { organization_id: organization.id, id: item_type.to_param,
                               item_type: new_attributes }, session: valid_session
        expect { item_type.reload }.not_to change { item_type.title }
      end

      it 'assigns the requested item_type as @item_type' do
        put :update, params: { organization_id: organization.id, id: item_type.to_param,
                               item_type: attributes_for(:item_type) }, session: valid_session
        expect(assigns(:item_type)).to eq(item_type)
      end

      it 'redirects to the item_type' do
        put :update, params: { organization_id: organization.id, id: item_type.to_param,
                               item_type: { initial_state_id: create(:state).to_param } },
                     session: valid_session
        expect(response).to redirect_to([organization, item_type])
      end
    end

    context 'with invalid params' do
      it 'assigns the item_type as @item_type' do
        put :update, params: { organization_id: organization.id, id: item_type.to_param,
                               item_type: invalid_attributes }, session: valid_session
        expect(assigns(:item_type)).to eq(item_type)
      end

      it "re-renders the 'edit' template" do
        put :update, params: { organization_id: organization.id, id: item_type.to_param,
                               item_type: invalid_attributes }, session: valid_session
        expect(response).to render_template('edit')
      end
    end
  end

  describe 'DELETE #destroy' do
    before(:each) do
      create(:item_type)
      request.env['HTTP_REFERER'] = root_path
    end

    let(:item_type) { ItemType.last }

    it 'destroys the requested item_type' do
      expect do
        item_type.states.first.destroy
        delete :destroy, params: { organization_id: item_type.organization,
                                   id: item_type.to_param },
                         session: valid_session
      end.to change(ItemType, :count).by(-1)
    end

    it 'redirects to the item_types list' do
      item_type.states.first.destroy
      delete :destroy, params: { organization_id: item_type.organization, id: item_type.to_param },
                       session: valid_session
      expect(response).to redirect_to(organization_item_types_url(item_type.organization))
    end
  end
end
